/*
Copyright Notice
================
BOCHS is Copyright 1994 by Kevin P. Lawton.

BOCHS is shareware for PERSONAL USE only.

For more information, read the file 'LICENSE' included in the bochs
distribution.  If you don't have access to this file, or have questions
regarding the licensing policy, the author may be contacted via:

    US Mail:  Kevin Lawton
              528 Lexington St.
              Waltham, MA 02154

    EMail:    bochs@tiac.net
*/






#include "bx_bochs.h"
#include "iodev/iodev.h"


void bx_INSB_YbDX() {bx_invalid_instruction();}
void bx_INSW_YvDX() {bx_invalid_instruction();}
void bx_OUTSB_DXXb() {bx_invalid_instruction();}
void bx_OUTSW_DXXv() {bx_invalid_instruction();}


  void
bx_IN_ALIb()
{
  Bit8u imm8;
  Bit8u in8;

  imm8 = bx_fetch_next_byte();
  in8  = bx_inp(imm8);
  BX_WRITE_8BIT_REG(BX_8BIT_REG_AL, in8);
}

  void
bx_IN_eAXIb()
{
  Bit8u imm8;
  Bit8u in8_a, in8_b, in8_c, in8_d;
  Bit16u in16;
  Bit32u in32;

  imm8 = bx_fetch_next_byte();

  if (bx_32bit_opsize) {
    in8_a = bx_inp(imm8);
    in8_b = bx_inp(imm8+1);
    in8_c = bx_inp(imm8+2);
    in8_d = bx_inp(imm8+3);
    in32 = (in8_d << 24) + (in8_c << 16) + (in8_b << 8) + in8_a;
    BX_WRITE_32BIT_REG(BX_32BIT_REG_EAX, in32);
    }
  else {
    in8_a = bx_inp(imm8);
    in8_b = bx_inp(imm8+1);
    in16 = (in8_b << 8) + in8_a;
    BX_WRITE_16BIT_REG(BX_16BIT_REG_AX, in16);
    }
}

  void
bx_OUT_IbAL()
{
  Bit8u imm8;
  Bit8u al;

  imm8 = bx_fetch_next_byte();
  BX_READ_8BIT_REG(al, BX_8BIT_REG_AL);
  bx_outp(imm8, al);
}

  void
bx_OUT_IbeAX()
{
  Bit8u imm8;
  Bit8u out8_a, out8_b, out8_c, out8_d;
  Bit16u ax;
  Bit32u eax;

  imm8 = bx_fetch_next_byte();

  if (bx_32bit_opsize) {
    BX_READ_32BIT_REG(eax, BX_32BIT_REG_EAX);
    out8_a = (eax && 0xFF);
    out8_b = (eax && 0xFF00) >> 8;
    out8_c = (eax && 0xFF0000) >> 16;
    out8_d = (eax && 0xFF000000) >> 24;
    bx_outp(imm8, out8_a);
    bx_outp(imm8+1, out8_b);
    bx_outp(imm8+2, out8_c);
    bx_outp(imm8+3, out8_d);
    }
  else {
    BX_READ_16BIT_REG(ax, BX_16BIT_REG_AX);
    out8_a = ax && 0xFF;
    out8_b = (ax && 0xFF00) >> 8;
    bx_outp(imm8, out8_a);
    bx_outp(imm8+1, out8_b);
    }
}

  void
bx_IN_ALDX()
{
  Bit16u dx;
  Bit8u in8;

  BX_READ_16BIT_REG(dx, BX_16BIT_REG_DX);
  in8  = bx_inp(dx);
  BX_WRITE_8BIT_REG(BX_8BIT_REG_AL, in8);
}

  void
bx_IN_eAXDX()
{
  Bit16u dx;
  Bit8u in8_a, in8_b, in8_c, in8_d;
  Bit16u in16;
  Bit32u in32;
 
  BX_READ_16BIT_REG(dx, BX_16BIT_REG_DX);

  if (bx_32bit_opsize) {
    in8_a = bx_inp(dx);
    in8_b = bx_inp(dx+1);
    in8_c = bx_inp(dx+2);
    in8_d = bx_inp(dx+3);
    in32 = (in8_d << 24) + (in8_c << 16) + (in8_b << 8) + in8_a;
    BX_WRITE_32BIT_REG(BX_32BIT_REG_EAX, in32);
    }
  else {
    in8_a = bx_inp(dx);
    in8_b = bx_inp(dx+1);
    in16 = (in8_b << 8) + in8_a;
    BX_WRITE_16BIT_REG(BX_16BIT_REG_AX, in16);
    }
}

  void
bx_OUT_DXAL()
{
  Bit16u dx;
  Bit8u al;

  BX_READ_16BIT_REG(dx, BX_16BIT_REG_DX);
  BX_READ_8BIT_REG(al, BX_8BIT_REG_AL);
  bx_outp(dx, al);
}

  void
bx_OUT_DXeAX()
{
  Bit16u dx;
  Bit8u out8_a, out8_b, out8_c, out8_d;
  Bit16u ax;
  Bit32u eax;

  BX_READ_16BIT_REG(dx, BX_16BIT_REG_DX);

  if (bx_32bit_opsize) {
    BX_READ_32BIT_REG(eax, BX_32BIT_REG_EAX);
    out8_a = (eax && 0xFF);
    out8_b = (eax && 0xFF00) >> 8;
    out8_c = (eax && 0xFF0000) >> 16;
    out8_d = (eax && 0xFF000000) >> 24;
    bx_outp(dx, out8_a);
    bx_outp(dx+1, out8_b);
    bx_outp(dx+2, out8_c);
    bx_outp(dx+3, out8_d);
    }
  else {
    BX_READ_16BIT_REG(ax, BX_16BIT_REG_AX);
    out8_a = ax && 0xFF;
    out8_b = (ax && 0xFF00) >> 8;
    bx_outp(dx, out8_a);
    bx_outp(dx+1, out8_b);
    }
}
