/*
Copyright Notice
================
BOCHS is Copyright 1994 by Kevin P. Lawton.

BOCHS is shareware for PERSONAL USE only.

For more information, read the file 'LICENSE' included in the bochs
distribution.  If you don't have access to this file, or have questions
regarding the licensing policy, the author may be contacted via:

    US Mail:  Kevin Lawton
              528 Lexington St.
              Waltham, MA 02154

    EMail:    bochs@tiac.net
*/








#include "bx_bochs.h"

  Bit16u
bx_read_segment_register(Bit32u index)
{
  bx_error(1, "bx_read_segment_register() not yet implemented!\n");
  return(0); /* keep compiler from complaining */
}

  void
bx_write_segment_register(Bit32u index, Bit16u value)
{
  bx_error(1, "bx_write_segment_register() not yet implemented!\n");
}

  void
bx_load_seg_reg(int seg_reg, Bit16u new_value)
{
#if 0
  switch (seg_reg) {
    case BX_SEG_REG_CS:
      if (bx_32bit_addrsize) {
        bx_error(1, "32bit addressing not yet supported!\n");
	}
      else { /* 16 bit address mode */
        bx_CS.selector.index =
        bx_CS.selector.ti    =
        bx_CS.selector.rpl   = 0;
	bx_CS.base =
        bx_CS.limit =
        bx_CS.attributes.d
        bx_CS.attributes.p
        bx_CS.attributes.dpl
        bx_CS.attributes.s
        bx_CS.attributes.type
        }
      break;
    case BX_SEG_REG_DS:
      break;
    case BX_SEG_REG_ES:
      break;
    case BX_SEG_REG_SS:
      break;
      }
#endif /* if 0 ... */
}



  void
bx_LES_GvMp()
{
  Bit32u reg_addr, mem_addr;
  Bit16u reg_16, es;
  int mem_type;
  bx_segment_reg_t *mem_seg_reg;

  bx_decode_exgx(&reg_addr, &mem_addr, &mem_type, &mem_seg_reg);
  
  if (bx_32bit_addrsize) {
    bx_error(1, "do not know how to do LES in 32bit address mode!\n");
    }
  else { /* 16 bit mode */
    if (mem_type == BX_MEMORY_REF) {
      bx_access_virtual(mem_seg_reg, mem_addr, 2, BX_READ, &reg_16);
      bx_access_virtual(mem_seg_reg, mem_addr + 2, 2, BX_READ, &es);
      bx_cpu.es.selector.value = es;
      BX_WRITE_8BIT_REG(reg_addr, reg_16);
      }
    else {
      bx_error(1, "invalid use of LES, must use memory reference!\n");
      }
    }
}

  void
bx_LDS_GvMp()
{
  Bit32u reg_addr, mem_addr;
  Bit16u reg_16, ds;
  int mem_type;
  bx_segment_reg_t *mem_seg_reg;

  bx_decode_exgx(&reg_addr, &mem_addr, &mem_type, &mem_seg_reg);
  
  if (bx_32bit_addrsize) {
    bx_error(1, "do not know how to do LES in 32bit address mode!\n");
    }
  else { /* 16 bit mode */
    if (mem_type == BX_MEMORY_REF) {
      bx_access_virtual(mem_seg_reg, mem_addr, 2, BX_READ, &reg_16);
      bx_access_virtual(mem_seg_reg, mem_addr + 2, 2, BX_READ, &ds);
      bx_cpu.ds.selector.value = ds;
      BX_WRITE_8BIT_REG(reg_addr, reg_16);
      }
    else {
      bx_error(1, "invalid use of LES, must use memory reference!\n");
      }
    }
}

void bx_LFS_Mp() {bx_invalid_instruction();}
void bx_LGS_Mp() {bx_invalid_instruction();}
void bx_LSS_Mp() {bx_invalid_instruction();}
