/*
Copyright Notice
================
BOCHS is Copyright 1994 by Kevin P. Lawton.

BOCHS is shareware for PERSONAL USE only.

For more information, read the file 'LICENSE' included in the bochs
distribution.  If you don't have access to this file, or have questions
regarding the licensing policy, the author may be contacted via:

    US Mail:  Kevin Lawton
              528 Lexington St.
              Waltham, MA 02154

    EMail:    bochs@tiac.net
*/







#include "bx_bochs.h"

extern Boolean bx_async_event;
extern Boolean bx_INTR;
extern Bit8u   bx_INTR_vector;


void bx_BOUND_GvMa() {bx_invalid_instruction();}

  void
bx_INT3()
{
  bx_async_event = 1;
  bx_INTR = 1;
  bx_INTR_vector = 3;

  /* INT3 affects the following flags: I,T */

  bx_cpu.eflags.if_ = 0;
  bx_cpu.eflags.tf  = 0;
}

  void
bx_INT_Ib()
{
  Bit8u imm8;

  imm8 = bx_fetch_next_byte();

  bx_async_event = 1;
  bx_INTR = 1;
  bx_INTR_vector = imm8;

  /* INT affects the following flags: I,T */

  bx_cpu.eflags.if_ = 0;
  bx_cpu.eflags.tf  = 0;
}

  void
bx_INTO()
{
  if (bx_cpu.eflags.of) {
    bx_async_event = 1;
    bx_INTR = 1;
    bx_INTR_vector = 4;

    /* INTO affects the following flags: I,T */

    bx_cpu.eflags.if_ = 0;
    bx_cpu.eflags.tf  = 0;
    }
}

