/*
Copywrite 1994 by Kevin P. Lawton 

This file is part of the IODEV (Input Output DEVices) component of BOCHS.

The IODEV component is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

The IODEV component is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the IODEV component; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "iodev.h"


  void
bx_bios_post(void)
{
  /*--- 8259A PIC ---*/
  bx_init_pic();

  /*--- 8254 PIT ---*/
  bx_init_pit();
  bx_register_int_vector(0x08, 0, bx_pit_int_handler);

  /*--- 8237 DMA controller ---*/
  bx_init_dma();

  /*--- 8042 keyboard controller ---*/
  bx_init_keyboard();
  bx_register_int_vector(0x09, 0, bx_keyboard_int_handler);

  /*--- CMOS RAM & RTC ---*/
  bx_init_cmos();
  bx_register_int_vector(0x70, 0, bx_cmos_rtc_int_handler);

  /*--- HARD DRIVE ---*/
  bx_init_hard_drive();
  bx_register_int_vector(0x76, 0, bx_hard_drv_int_handler);

  /*--- PARALLEL PORT ---*/
  bx_init_parallel();
  bx_register_int_vector(0x0F, 0, bx_parallel_int_handler);

  /*--- SERIAL PORT ---*/
  bx_init_serial();
  bx_register_int_vector(0x0C, 0, bx_serial_int_handler);

  /*--- FLOPPY DRIVE CONTROLLER ---*/
  bx_init_floppy();
  bx_register_int_vector(0x0E, 0, bx_floppy_int_handler);

  /*--- VGA adapter ---*/
  bx_init_vga();

}
